package ru.dbotthepony.kstarbound.client.network.packets

import com.google.gson.JsonObject
import ru.dbotthepony.kstarbound.client.network.ClientConnection
import ru.dbotthepony.kstarbound.json.readJsonObject
import ru.dbotthepony.kstarbound.json.writeJsonObject
import ru.dbotthepony.kstarbound.network.IClientPacket
import ru.dbotthepony.kstarbound.world.entities.WorldObject
import java.io.DataInputStream
import java.io.DataOutputStream

class SpawnWorldObjectPacket(val data: JsonObject) : IClientPacket {
	constructor(stream: DataInputStream) : this(stream.readJsonObject())

	override fun write(stream: DataOutputStream) {
		stream.writeJsonObject(data)
	}

	override fun play(connection: ClientConnection) {
		connection.client.mailbox.execute {
			val world = connection.client.world ?: return@execute
			val obj = WorldObject.fromJson(data)
			val chunk = world.chunkMap[world.geometry.chunkFromCell(obj.pos)] ?: return@execute
			chunk.addObject(obj)
		}
	}
}
